"use strict";
/* eslint-disable camelcase */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AccountManager = void 0;
var binding_1 = __importDefault(require("./binding"));
var constants_1 = require("./constants");
var events_1 = require("events");
var fs_1 = require("fs");
var debug_1 = __importDefault(require("debug"));
var os_1 = require("os");
var path_1 = require("path");
var context_1 = require("./context");
var debug = debug_1.default('deltachat:node:index');
var noop = function () { };
/**
 * Wrapper around dcn_account_t*
 */
var AccountManager = /** @class */ (function (_super) {
    __extends(AccountManager, _super);
    function AccountManager(cwd, os) {
        if (os === void 0) { os = 'deltachat-node'; }
        var _this = this;
        debug('DeltaChat constructor');
        _this = _super.call(this) || this;
        _this.accountDir = cwd;
        _this.dcn_accounts = binding_1.default.dcn_accounts_new(os, _this.accountDir);
        return _this;
    }
    AccountManager.prototype.getAllAccountIds = function () {
        return binding_1.default.dcn_accounts_get_all(this.dcn_accounts);
    };
    AccountManager.prototype.selectAccount = function (account_id) {
        return binding_1.default.dcn_accounts_select_account(this.dcn_accounts, account_id);
    };
    AccountManager.prototype.selectedAccount = function () {
        return binding_1.default.dcn_accounts_get_selected_account(this.dcn_accounts);
    };
    AccountManager.prototype.addAccount = function () {
        return binding_1.default.dcn_accounts_add_account(this.dcn_accounts);
    };
    AccountManager.prototype.removeAccount = function (account_id) {
        return binding_1.default.dcn_accounts_remove_account(this.dcn_accounts, account_id);
    };
    AccountManager.prototype.accountContext = function (account_id) {
        var native_context = binding_1.default.dcn_accounts_get_account(this.dcn_accounts, account_id);
        return new context_1.Context(this, native_context, account_id);
    };
    AccountManager.prototype.migrateAccount = function (dbfile) {
        return binding_1.default.dcn_accounts_migrate_account(this.dcn_accounts, dbfile);
    };
    AccountManager.prototype.close = function () {
        this.stopIO();
        debug('unrefing context');
        binding_1.default.dcn_accounts_unref(this.dcn_accounts);
        debug('Unref end');
    };
    AccountManager.prototype.emit = function (event, account_id, data1, data2) {
        _super.prototype.emit.call(this, 'ALL', event, account_id, data1, data2);
        return _super.prototype.emit.call(this, event, account_id, data1, data2);
    };
    AccountManager.prototype.handleCoreEvent = function (eventId, accountId, data1, data2) {
        var eventString = constants_1.EventId2EventName[eventId];
        debug('event', eventString, accountId, data1, data2);
        debug(eventString, data1, data2);
        if (!this.emit) {
            console.log('Received an event but EventEmitter is already destroyed.');
            console.log(eventString, data1, data2);
            return;
        }
        this.emit(eventString, accountId, data1, data2);
    };
    AccountManager.prototype.startEvents = function () {
        if (this.dcn_accounts === null) {
            throw new Error('dcn_account is null');
        }
        binding_1.default.dcn_accounts_start_event_handler(this.dcn_accounts, this.handleCoreEvent.bind(this));
        debug('Started event handler');
    };
    AccountManager.prototype.startIO = function () {
        binding_1.default.dcn_accounts_start_io(this.dcn_accounts);
    };
    AccountManager.prototype.stopIO = function () {
        binding_1.default.dcn_accounts_stop_io(this.dcn_accounts);
    };
    AccountManager.createTempUser = function (url) {
        return __awaiter(this, void 0, void 0, function () {
            function postData(url) {
                if (url === void 0) { url = ''; }
                return __awaiter(this, void 0, void 0, function () {
                    var response;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, fetch(url, {
                                    method: 'POST',
                                    mode: 'cors',
                                    cache: 'no-cache',
                                    credentials: 'same-origin',
                                    headers: {
                                        'cache-control': 'no-cache',
                                    },
                                    referrerPolicy: 'no-referrer',
                                })];
                            case 1:
                                response = _a.sent();
                                return [2 /*return*/, response.json()]; // parses JSON response into native JavaScript objects
                        }
                    });
                });
            }
            var fetch;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        fetch = require('node-fetch');
                        return [4 /*yield*/, postData(url)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    AccountManager.maybeValidAddr = function (addr) {
        debug('DeltaChat.maybeValidAddr');
        if (addr === null)
            return false;
        return Boolean(binding_1.default.dcn_maybe_valid_addr(addr));
    };
    AccountManager.parseGetInfo = function (info) {
        debug('static _getInfo');
        var result = {};
        var regex = /^(\w+)=(.*)$/i;
        info
            .split('\n')
            .filter(Boolean)
            .forEach(function (line) {
            var match = regex.exec(line);
            if (match) {
                result[match[1]] = match[2];
            }
        });
        return result;
    };
    AccountManager.newTemporary = function () {
        var directory = null;
        while (true) {
            var randomString = Math.random().toString(36).substr(2, 5);
            directory = path_1.join(os_1.tmpdir(), 'deltachat-' + randomString);
            if (!fs_1.existsSync(directory))
                break;
        }
        var dc = new AccountManager(directory);
        var accountId = dc.addAccount();
        var context = dc.accountContext(accountId);
        return { dc: dc, context: context, accountId: accountId, directory: directory };
    };
    /** get information about the provider
     *
     * This function creates a temporary context to be standalone,
     * if posible use `Context.getProviderFromEmail` instead. (otherwise potential proxy settings are not used)
     * @deprecated
     */
    AccountManager.getProviderFromEmail = function (email) {
        debug('DeltaChat.getProviderFromEmail');
        var _a = AccountManager.newTemporary(), dc = _a.dc, context = _a.context;
        var provider = context.getProviderFromEmail(email);
        context.unref();
        dc.close();
        return provider;
    };
    return AccountManager;
}(events_1.EventEmitter));
exports.AccountManager = AccountManager;
//# sourceMappingURL=deltachat.js.map